import java.io.*;
import java.security.*;

			//  classe del Thread per il controllo "dinamico" delle risorse.
			// ( classe di uso interno) (avviata da Negoziatore)


	               //  @author	                  Matteo Fasanella


class Gestore extends Thread{

	public static boolean[] presenti = new boolean[2000000];
	private int[]  times = new int[2000000];
	private boolean[]  tout = new boolean[2000000];	
	static int delay;
	int logTimeOut = 0;
	String timeOut = "Your time has run Out";
	
	public Gestore ( int delay ) {
		
		delay = this.delay;
	} 


	 public void run()  {
		
		for (int i=0; i<=2000000; i++) {
		
			if (! presenti[i]) continue;
			
			if ( tout[i] ) { 
				tout[i] = false;  
				agentPrimitive.kill ( i, Negoziatore.myPublicKey, Negoziatore.mySign);
			}
			
			Key key = Negoziatore.searchUnkey (i);
			if ( AgentresManager.decMem( key, delay) == -1) { 
				agentTimeOut (i);
				tout[i] = true;
			}
		} 	
	 	try {
		   this.sleep(delay*60000);	
		} catch (Exception e) {}
		
		if ( (logTimeOut-=delay) <= 0 )  clearLog();
	 }



	private  void agentTimeOut (int unique) {
		
		// manda all'Agente "unique" la stringa TimeOut
	}


	private void clearLog() {
	
		byte[] currTime = timePrimitive.getTime();
		byte[] time = new byte[2];
	 	boolean esci = false;
	 	long i = 0;
		
		try {
		       
		    RandomAccessFile p = new RandomAccessFile ("log", "rw");
		    long pos = 798;
		   
		   while (! (esci == true) )     {

		        p.seek( pos );
		        
		        p.read(time);
		        if ( (currTime[0]-time[0]) > 24 )  {
		        		i ++;
			        pos = 798 + (804 * i);
			} else esci = true;
		    }
 	         p.close();       
		} catch (Exception e) { System.out.println ("eccezione: " + e.toString()); return;}
		
		deleteRecords( i );
	}
	
	
	private void deleteRecords (long i) {
	
		// cancella tutti i record fino all'i-esimo.	
	}
}