import java.security.*;

			//   Primitive per la gestione degli Agenti (creazione, distruzione e migrazione).

			 //  @author	                  Matteo Fasanella
		
class agentPrimitive {

	public int  clone( Key key, byte[] sign)     {
		
		if (! cryptoPrimitive.verify(Negoziatore.toByteArray(key), sign, key) ) return -1;
		if (AgentresManager.incAgents(key) != 0) return -1;


		byte[] ris = logManager.searchKey(key);
		int unique = ris[7] + ris[8]*100 + ris[9]*10000 + ris[10]*1000000 + ris[11]*100000000;
		AgentID AgID = Negoziatore.searchUnique( unique);
		
		AgentID agentID = AgentManager.clone(AgID);
		
		int uniqueID = Negoziatore.nextUnique();
	
		Negoziatore.addUnique (uniqueID, agentID);
		
		byte[] nextPlace = new byte[4];
		byte[] time = timePrimitive.getTime();
		byte[] timeToPass = new byte[2];             timeToPass[0] = time[0];  timeToPass[1] = time[1];
		logManager.appendRecord ( key, uniqueID, 0, (byte) 1,  time, nextPlace);
		
		return uniqueID;	
	}
	
	
       	public  static void  kill   (int  UniqueID, Key key, byte[] sign)  {
       		
		if (! cryptoPrimitive.verify(Negoziatore.toByteArray(key), sign, key) ) return ;
		if (AgentresManager.decAgents(key) != 0) return ;	
		
		AgentID AgID = Negoziatore.searchUnique( UniqueID);	

		AgentSystem.kill(AgID);
	}
	

	public int agentMove ( int UniqueID, InetAddress To, int port, String metodo, Key key, byte[] sign)) {
	
				// not implemented yet....
		return -1;	
	}
	
	
}

