import java.util.*;
import java.text.*;

		       //   Primitiva per avere il tempo del sistema.   (GMT +0)
	               //  @author	                  Matteo Fasanella

class timePrimitive {

	public static  byte[] getTime() {    //  restituisce l'ora come   hh : mm : ss
		byte[] time = new byte[3];
		int s = 0, m=0, h= 0;
		
		Date currentDate = new Date();	
	        
	        SimpleDateFormat formatter = new SimpleDateFormat("s",Locale.getDefault());
	        try {
         	   s =  Integer.parseInt(formatter.format(currentDate));
	        } catch (NumberFormatException n) {    time[2] = 0;      }
	        formatter.applyPattern("m");
	        try {
         	   m = Integer.parseInt(formatter.format(currentDate));
	        } catch (NumberFormatException n) {     time[1] = 0;    }    
	        formatter.applyPattern("h");
	        try {
	           h =  Integer.parseInt(formatter.format(currentDate));
	        } catch (NumberFormatException n) {   time[0] = 0;     }
	        
	        int i = currentDate.getTimezoneOffset() ;
	        h = (h + (i/60));
	        if ( h < 0) h = h + 24;
	        
	        time[0] =(byte) h;    time[1] = (byte) m;    time[2] = (byte) s;

		return time;
	}
	
}