import java.io.*;
import java.net.*;
import java.security.*;

				//  Classe del Thread che gestisce la ricezione del pacchetto dati per un Alias interno.
				//   (classe di uso interno  (Negoziatore))

				 //  @author	                  Matteo Fasanella

class AliasManager extends Thread{
	InetAddress from;
	int fromPort;
	int port;
	Key  simmKey;
	int uniqueID;
	byte next;
	int alias;
	int timeOut = 60000;

	public AliasManager (byte[] From, int fromPort, int nextFreePort, byte[] SimmKey, int toAgent, byte next, int alias) {
		from = Negoziatore.htons (From);
		fromPort = this.fromPort;
		port = nextFreePort;
		uniqueID = toAgent;
		next = this.next;
		alias = this.alias;
		
		simmKey = new iaik.security.cipher.SecretKey(SimmKey, "RAW");		
	}
	
	
	public void run() {
		
		int rd = 0;
		DatagramSocket receiver = null;  
		byte[] packet = new byte[1024];
	     	byte[] data = new byte[1024 * next];		
		
		try {
              		receiver = new DatagramSocket( port );
              		
		     	DatagramPacket recvPacket = new DatagramPacket ( new byte[1024], 1024);
		     	
		     	byte[] serializedPort = new byte[3];   
		     	serializedPort[0] = (byte) (port % 100);             port = port / 100;
		     	serializedPort[1] = (byte) (port % 100);             port = port / 100;		     	
		     	serializedPort[2] = (byte) (port % 100);		     	
		     	DatagramPacket sendPacket = new DatagramPacket ( cryptoPrimitive.cypher(serializedPort, simmKey), 2, from, fromPort);
		     	receiver.send(sendPacket);
		     	
			for (int i=1; i<=next; i++) {
				receiver.setSoTimeout(timeOut);				
				receiver.receive(recvPacket);
				packet = cryptoPrimitive.decypher( recvPacket.getData(), simmKey);
				
				for (int j=1; j<=rd; j++)    data[ 1024*(next-1) + j] = packet[j];
			}     // legge i pacchetti e li mette in   data
			
		} catch (InterruptedIOException ex) { // che si fa in caso il pacchetto di alias non arriva ?
						return;		//  Semplice, Abortiamo la richiesta.... 
		} catch (Exception SE) {  return;  }
		
           	copyToMailBox (data, uniqueID);
           	logManager.deleteAlias(alias);
           		
	}
	
	
	
	private int copyToMailBox (byte[] data, int unique)  {
		
		AgentID agente = Negoziatore.searchUnique(unique);
		
		// copia il pacchetto data nella MailBox dell'Agente....
		
	}
	
	
	
}