import java.io.*;
import java.security.*;
import iaik.security.rsa.*;

			//  Primitive per la gestione di un Indirizzo di Alias

	               //  @author	                  Matteo Fasanella

class aliasPrimitive {

	public int     Alias(Key key, byte[] sign) {
		int alias = Negoziatore.nextAlias();
	
		if (! cryptoPrimitive.verify(Negoziatore.toByteArray(key), sign, key) ) return -1;
	
		logManager.appendRecord ( key, alias);

		return alias;
	}
	
        public void  setNextPlace(int alias, byte[] address, Key key, byte[] sign)  {
        	
	        	if (! cryptoPrimitive.verify(Negoziatore.toByteArray(key), sign, key) ) return ;
        		if (! logManager.checkAlias(alias, key) )  return ;
        		
       	       long pos = Negoziatore.searchLog(alias);
       	       
      		try {
		        RandomAccessFile p = new RandomAccessFile ("log", "rw");
			
			p.seek(pos+800);
		        p.write(address);
		        p.close();       
		} catch (Exception e) { System.out.println ("eccezione: " + e.toString()); return ;}

        }


}