import java.security.*;
import java.io.*;
import iaik.utils.*;

			//   Classe per la gestione del Log.         (ad  uso interno).

			 //  @author	                  Matteo Fasanella

public class logManager {


	public static synchronized int appendRecord ( Key publicKey, int UniqueID, int Alias, byte present, byte[] time, byte[] nextPlace) {
		long pos;
		
		try {
			
		       byte[] serializedKey;
		       ByteArrayOutputStream baos = new ByteArrayOutputStream();
		       ObjectOutputStream oos = new ObjectOutputStream (baos);
		       oos.writeObject (publicKey);
		       serializedKey = baos.toByteArray();
		       
		        RandomAccessFile p = new RandomAccessFile ("log", "rw");
		        pos = p.length();
		        p.seek( pos );
		        p.write(serializedKey);
		        p.writeInt(UniqueID);
		        p.writeInt(Alias);
		        p.writeByte(present);
		        p.write(time);
		        p.write(nextPlace);
		        p.writeInt( (int)  0);
		        p.close();       
		} catch (Exception e) { System.out.println ("eccezione: " + e.toString()); return -1;}
		
		Negoziatore.addLog ( Alias, (pos/808) );
		
		return 0;
	}


	public static synchronized int appendRecord ( Key publicKey, int Alias) {
		long pos;
		int UniqueID =0;
		byte present = 0;
		byte[] time = new byte[2];
		byte[] nextPlace = new byte[4];
		
		try {
			
		       byte[] serializedKey = new byte[789];
		       
	       	       pos = Negoziatore.searchLogKey(publicKey);
		       
		        RandomAccessFile p = new RandomAccessFile ("log", "rw");
			
			p.seek(pos);
			p.read(serializedKey);
			UniqueID =p.readInt();
			p.readInt();
			present = p.readByte();
			p.read(time);
			p.read(nextPlace);

		        p.seek( p.length() );
		        p.write(serializedKey);
		        p.writeInt(UniqueID);
		        p.writeInt(Alias);
		        p.writeByte(present);
		        p.write(time);
		        p.write(nextPlace);
		        p.writeInt( (int)  0);		        
		        p.close();       
		} catch (Exception e) { System.out.println ("eccezione: " + e.toString()); return -1;}
		
		Negoziatore.addLog ( Alias, (pos/808) );
		
		return 0;
	}

	
	public static byte[] searchAlias (int alias) {
		
		byte[] serializedKey = new byte[789];
		Key key;
		
		byte[] ritorno = new byte[16];   //    Present,  Time,  NextPlace, UniqueID, NextAlias
		ritorno[0] = -1;

		long pos = Negoziatore.searchLog( alias);
		if ( pos == -1) return ritorno;

	     try {  	          
  	          RandomAccessFile p = new RandomAccessFile ("log", "rw");	     	
  	          p.seek(797 + (pos * 808) );
  		 
		ritorno[0] = p.readByte();  		// Present byte
		ritorno[1] = p.readByte();		// Time hh  byte
		ritorno[2] = p.readByte();		// Time mm byte
		ritorno[3] = p.readByte();		// NextPlace bytes
		ritorno[4] = p.readByte();  		
		ritorno[5] = p.readByte();  		
		ritorno[6] = p.readByte();
		
	         p.seek(789 + (pos * 808) );
	         int uniqueID = p.readInt();        //  UniqueID come 2.0|00|.00|0.0|00
	         ritorno[7] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[8] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[9] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[10] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[11] = (byte) (uniqueID );                
	         
	         int nextAlias = p.readInt();        //  nextAlias  come 6|5.0|00
	         ritorno[12] = (byte) (nextAlias % 100);                  nextAlias = nextAlias / 100;
	         ritorno[13] = (byte) (nextAlias % 100);                  nextAlias = nextAlias / 100;
	         ritorno[14] = (byte) (nextAlias % 100);                  nextAlias = nextAlias / 100;
	         ritorno[15] = (byte) (nextAlias % 100);                  

	         
	         
         	p.close();
		return ritorno;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ritorno; }
	}


	public static byte[] searchKey (Key key) {
		
		byte[] ritorno = new byte[12];   //    Present,  Time,  NextPlace, UniqueID
		ritorno[0] = -1;

		long pos = Negoziatore.searchLogKey( key);
		if ( pos == -1) return ritorno;

	     try {  	          
  	          RandomAccessFile p = new RandomAccessFile ("log", "rw");	     	
  	          p.seek(797 + (pos * 808) );
  		 
		ritorno[0] = p.readByte();  		// Present byte
		ritorno[1] = p.readByte();		// Time hh  byte
		ritorno[2] = p.readByte();		// Time mm byte
		ritorno[3] = p.readByte();		// NextPlace bytes
		ritorno[4] = p.readByte();  		
		ritorno[5] = p.readByte();  		
		ritorno[6] = p.readByte();
		
	         p.seek(789 + (pos * 808) );
	         int uniqueID = p.readInt();        //  UniqueID come 2.0|00|.00|0.0|00
	         ritorno[7] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[8] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[9] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[10] = (byte) (uniqueID % 100);                  uniqueID = uniqueID / 100;
	         ritorno[11] = (byte) (uniqueID );                
	         
         	p.close();
		return ritorno;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ritorno; }
	}

	
	public static boolean  checkAlias (int alias, Key agentKey) {
		
		byte[] serializedKey = new byte[789];
		Key key;

		long pos = Negoziatore.searchLog( alias);
		if ( pos == -1) return false;
		
		try {
  	          RandomAccessFile p = new RandomAccessFile ("log", "rw");
  	          
  	          p.seek( pos * 808);
  	          p.read(serializedKey);
  	          
  		  byte[] serializedAgentKey;
		  ByteArrayOutputStream baos = new ByteArrayOutputStream();
		  ObjectOutputStream oos = new ObjectOutputStream (baos);
		  oos.writeObject (agentKey);
		  serializedAgentKey = baos.toByteArray();
		       
		 if (CryptoUtils.equalsBlock( serializedKey, serializedAgentKey) )  return true;
		 return false;
		} catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return false; }		 
	}

	public static byte[] getRecord ( int num) {        // deprecated....
		
		byte[] ritorno = new byte[7]; //   Present,  Time,  NextPlace
		ritorno[0] = -1;
		byte[] serializedKey = new byte[789];
		
		try {
  	            RandomAccessFile p = new RandomAccessFile ("log", "rw");
	        	    
	             p.seek( 0 );
	             p.read( serializedKey);
//	             System.out.println(" key: " + new String(serializedKey).toString() );
		     p.seek(789);
		     
	             System.out.println(" AgentID: " + p.readInt() );
	             System.out.println(" Alias: " + p.readInt() );	             
	             System.out.println(" Present: " + p.readByte() );
	             System.out.println(" Time: " + p.readByte() +":"+ p.readByte() );	             	             
	             
	             p.close();
	             return ritorno;
  		  }  catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return ritorno; }
		
	}
	
	public static synchronized int deleteAlias (int alias) {
	
		long pos = Negoziatore.searchLog (alias);
		if (pos == -1) return -1;
		
		Negoziatore.delLog (alias);
		try {
  	            RandomAccessFile p = new RandomAccessFile ("log", "rw");
	        	    
		    p.seek(793 + (pos * 808) );
		    p.writeInt(-1);                                   //   -1  <=>  niente Alias
	             
	             p.close();
	             return 0;
  		  }  catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}


	public static synchronized int addNextAlias (int alias, int nextAlias) {
	
		long pos = Negoziatore.searchLog (alias);
		if (pos == -1) return -1;
		
		try {
  	            RandomAccessFile p = new RandomAccessFile ("log", "rw");
	        	    
		    p.seek(804 + (pos * 808) );
		    p.writeInt(nextAlias);
	             
	             p.close();
	             return 0;
  		  }  catch (Exception e) { System.out.println( "Exception: "+ e.toString()); return -1; }
	}


}