import java.security.*;
import java.util.*;
import javax.crypto.*;
import javax.crypto.Cipher;
import iaik.utils.*;
import iaik.utils.CryptoUtils;
import iaik.security.rsa.*;
import java.io.*;
import iaik.security.provider.*;

import cryptoPrimitive;

class provaPrimitive {

 static byte[] des3Key = {
    (byte)0x01,(byte)0x23,(byte)0x45,(byte)0x67,(byte)0x89,(byte)0xab,(byte)0xcd,(byte)0xef,
    (byte)0xf0,(byte)0xe1,(byte)0xd2,(byte)0xc3,(byte)0xb4,(byte)0xa5,(byte)0x96,(byte)0x87,
    (byte)0xfe,(byte)0xdc,(byte)0xba,(byte)0x98,(byte)0x76,(byte)0x54,(byte)0x32,(byte)0x10};

//  static byte[] packet = new String("123456789 prova 987654321").getBytes();
    static  byte[] packet = new byte[1024];


  public static void main(String argv[]) {
     RSAPrivateKey privateKey =null; 
     RSAPublicKey  publicKey = null;  
     
     long start, stop, gap;
     
/*
   try {   	
     KeyPairGenerator generator = KeyPairGenerator.getInstance("RSA");   
     generator.initialize(1024);  				          
     KeyPair kp = generator.generateKeyPair();    	
     privateKey =  (RSAPrivateKey)  kp.getPrivate();
     publicKey  =  (RSAPublicKey)   kp.getPublic();
   } catch (Exception ex) {
         System.out.println("Exception: "+ex.getMessage());
   }		 	
   System.out.println (" chiavi generate..."); 
   

      try {
       FileOutputStream ostream = new FileOutputStream("privateKey");
       ObjectOutputStream p = new ObjectOutputStream(ostream);
       p.writeObject(privateKey);
       p.flush();
       ostream.close();       
       FileOutputStream ostream2 = new FileOutputStream("publicKey");
       ObjectOutputStream p2 = new ObjectOutputStream(ostream2);
       p2.writeObject(publicKey);
       p2.flush();
       ostream2.close();              
   } catch (Exception e) {}
   System.out.println (" chiavi salvate...");   */

/*
      try {
       FileInputStream instream = new FileInputStream("privateKey");
       ObjectInputStream p = new ObjectInputStream(instream);
       privateKey = (RSAPrivateKey) p.readObject();
       instream.close();       
       FileInputStream instream2 = new FileInputStream("publicKey");
       ObjectInputStream p2 = new ObjectInputStream(instream2);
       publicKey = (RSAPublicKey) p2.readObject();
       instream2.close();       
   } catch (Exception e) {}
//   System.out.println (" keys loaded...");  

/*
    Random random = new Random();
    random.nextBytes(packet);    

*/
     cryptoPrimitive cryptoObject = new cryptoPrimitive();
/*
     start = System.currentTimeMillis();
     byte[] encripted = cryptoObject.cypher(packet,  privateKey );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				
     if (encripted[0] == -1)  {     System.out.println ( "RSA encription error" ); return; }
     System.out.println("RSA encripted " + new String(packet).length() + " bytes in:  " + gap+ " msec");

     start = System.currentTimeMillis();
     byte[] decripted = cryptoObject.decypher(encripted,  publicKey );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				
     if (decripted[0] == -1)  {     System.out.println ( "RSA decription: error" ); return; }
//     System.out.println ( "RSA decripted: " + new String(decripted).toString() );
     System.out.println("RSA decripted " + new String(encripted).length() + " bytes in:  " + gap+ " msec");

     Key desKey = new iaik.security.cipher.SecretKey(des3Key, "RAW");
     start = System.currentTimeMillis();     
     byte[] DESencripted = cryptoObject.cypher(packet,  desKey );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				     
     if (DESencripted[0] == -1)  {     System.out.println ( "DES encription error" ); return; }
     System.out.println("DES encripted " + new String(packet).length() + " bytes in:  " + gap+ " msec");

     start = System.currentTimeMillis();     
     byte[] DESdecripted = cryptoObject.decypher(DESencripted,  desKey);
     stop = System.currentTimeMillis();			
     gap = (stop-start);				          
     if (DESdecripted[0] == -1)  {     System.out.println ( "DES decription: error" ); return; }
  //   System.out.println ( "DES decripted: " + new String(DESdecripted).toString() );
     System.out.println("DES decripted " + new String(DESencripted).length() + " bytes in:  " + gap+ " msec");

     start = System.currentTimeMillis();     
     byte[] nullencripted = cryptoObject.cypher(packet,  null );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				               
     if (nullencripted[0] == -1)  {     System.out.println ( "null RSA encription error" ); return; }
     System.out.println("null RSA encripted " + new String(packet).length() + " bytes in:  " + gap+ " msec");

     start = System.currentTimeMillis();     
     byte[] nulldecripted = cryptoObject.decypher(nullencripted,  null );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				                    
     if (nulldecripted[0] == -1)  {     System.out.println ( "null RSA decription: error" ); return; }
//     System.out.println ( "null RSA decripted: " + new String(nulldecripted).toString() );
     System.out.println("null RSA decripted " + new String(nullencripted).length() + " bytes in:  " + gap+ " msec");     

     start = System.currentTimeMillis();     
     byte[] signed = cryptoObject.sign(packet, privateKey );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				               
     if (signed[0] == -1)  {     System.out.println ( "Signing error" ); return; }
     System.out.println("Signed  " + new String(packet).length() + " bytes in:  " + gap+ " msec");
     System.out.println("Signed  packet length:" + new String(signed).length() );

     start = System.currentTimeMillis();     
     byte[] nullsigned = cryptoObject.sign(packet, null );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				               
     if (nullsigned[0] == -1)  {     System.out.println ( "null Signing error" ); return; }
     System.out.println("null Signed  " + new String(packet).length() + " bytes in:  " + gap+ " msec");
     System.out.println("null Signed  packet length:" + new String(signed).length() );
     
     start = System.currentTimeMillis();     
     boolean verified = cryptoObject.verify(packet, signed, publicKey );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				               
     if (verified == false)  {     System.out.println ( "Verify error" ); return; }
     System.out.println("verified  " + new String(packet).length() + " bytes in:  " + gap+ " msec");

     start = System.currentTimeMillis();     
     boolean nullverified = cryptoObject.verify(packet, nullsigned, null );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				               
     if (nullverified == false)  {     System.out.println ( "null Verify error" ); return; }
     System.out.println("nullverified  " + new String(packet).length() + " bytes in:  " + gap+ " msec");

     start = System.currentTimeMillis();     
     Key des3Key= cryptoObject.createKey( );
     stop = System.currentTimeMillis();			
     gap = (stop-start);				               
     if (des3Key == null)  {     System.out.println ( "Key creation error" ); return; }
     System.out.println("key created is:  " + des3Key.toString().length() + "  bytes, in:  " + gap+ " msec");
*/

  }


}